{This program needs Borland Pascal 7.1 or higher}
uses Graph,Crt,Dos;
const Width=32; Height=20;
type Picture=array [0..Width-1,0..Height-1] of char;
type sprite=record
 State,X,Y,Pnum,Predir: word;
end;
const VGAPath='d:\TP7\EGAVGA.BGI';
      FontPath='d:\TP7\TRIP.CHR';
      SprName='attack.res';
const ESC=#27;
      F1=#59;
      SPACE=#32;
      UP=#72;  DOWN=#80;
      LEFT=#75; RIGHT=#77;
const MaxX=639; MaxY=479;
      Cx=MaxX div 2; Cy=MaxY div 2;
      MaxSprites=11;
      MaxPictures=11;
      MaxShoots=100;
const LeftDir=0;
      RightDir=1;
      UpDir=2;
      DownDir=3;
      Delta=2;
      ShootRadius=5;
var Ch:char;
    s:String;
    Hour,Min,Sec,Sec1,SecN,SecN1,Sec100,SecI,SecI1:Word;
var Driver, Mode, Font1, CurrentSprites, CurrentBottom,
    CurrentShoots, ShootX, Lives, EnemyShooter, Enemies,
    ShootsProbability: integer;
    Score,Level:longint;
    DriverF,FontF: file;
    DriverP,FontP: pointer;
    Spr: array [1..MaxSprites] of Sprite;
    Pict: array [1..MaxPictures] of Picture;
    Shoots: array [1..MaxShoots] of Sprite;
    Shooter,DieMe,InGame,InitShoot:boolean;

procedure Wait;
var Ch:char;
begin
 Reset (Input);
 repeat until KeyPressed;
 Ch:=Readkey;
 if Ch=#0 then Readkey;
end;

procedure CloseAll;
begin
 if FontP <> nil then begin
  FreeMem(FontP, FileSize(FontF));
  Close (FontF);
 end;
 if DriverP <> nil then begin
  FreeMem(DriverP, FileSize(DriverF));
  Close (DriverF);
 end;
 CloseGraph;
end;

procedure GraphError;
begin
 CloseAll;
 Writeln('Graphics error:', GraphErrorMsg(GraphResult));
 Writeln('Press any key to halt program...');
 Wait;
 Halt (GraphResult);
end;

procedure InitAll;
begin
 Assign(DriverF, VGAPath);
 Reset(DriverF, 1);
 GetMem(DriverP, FileSize(DriverF));
 BlockRead(DriverF, DriverP^, FileSize(DriverF));
 if RegisterBGIdriver(DriverP)<0 then GraphError;
 Driver:=VGA; Mode:=VGAHi;
 InitGraph(Driver, Mode,'');
 if GraphResult < 0 then GraphError;
 Assign(FontF, FontPath);
 Reset(FontF, 1);
 GetMem(FontP, FileSize(FontF));
 BlockRead(FontF, FontP^, FileSize(FontF));
 Font1:=RegisterBGIfont(FontP);
 if Font1 < 0 then GraphError;
end;

procedure ClearScreen;
begin
 setfillstyle (SolidFill, White);
 bar (0,0,MaxX,MaxY);
end;

procedure Window (x1,y1,x2,y2,Color,FillColor:integer);
begin
 SetColor (Color);
 SetFillStyle (1,FillColor);
 Bar (x1,y1,x2,y2);
 Rectangle (x1+2,y1+2,x2-2,y2-2);
 Rectangle (x1+4,y1+4,x2-4,y2-4);
 SetFillStyle (1,DARKGRAY);
 Bar (x1+8,y2+1,x2+8,y2+8);
 Bar (x2+1,y1+8,x2+8,y2);
end;

procedure outtextCxy (y:integer; s:string);
begin
 settextjustify (CenterText,CenterText);
 outtextxy (Cx ,y,s);
end;

procedure Start;
begin
 ClearScreen;
 Window (10,10,MaxX-10,MaxY-10,Blue,White);
 SetTextStyle(Font1, HorizDir, 4);
 outtextCxy (25,'⠪  ᬮ');
 SetTextStyle(Font1, HorizDir, 1);
 outtextCxy (MaxY-25,'  ⮭  砫');
 Wait;
end;

procedure RestoreScreen (SNum,Dir,Delta:word);
var X,Y:word;
begin
 X:=Spr[SNum].X;
 Y:=Spr[SNum].Y;
 setfillstyle (SolidFill,White);
 case Dir of
  LeftDir: begin
   bar (X+Width-Delta,Y,X+Width-1,Y+Height-1);
  end;
  RightDir: begin
   bar (X,Y,X+Delta,Y+Height-1);
  end;
  UpDir: begin
   bar (X,Y+Height-Delta,X+Width-1,Y+Height-1);
  end;
  DownDir: begin
   bar (X,Y,X+Width-1,Y+Delta);
  end;
 end;
end;

procedure DrawSprite (SNum:word);
var i,j,x,y,n,b:integer;
begin
 N:=Spr[SNum].PNum;
 x:=Spr[SNum].x;
 y:=Spr[SNum].y;
 for j:=y to y+Height-1 do
 for i:=x to x+Width-1 do begin
  b:=Ord(Pict[n,i-x,j-y]);
  putpixel(i,j,b);
 end;
end;

procedure GoLeft;
var X,d2:word;
begin
 X:=Spr[1].X;
 d2:=delta*4;
 if X>d2 then begin
  RestoreScreen (1,LeftDir,d2);
  Dec(Spr[1].X,d2);
  DrawSprite (1);
 end;
end;

procedure GoRight;
var X,d2:word;
begin
 X:=Spr[1].X;
 d2:=delta*4;
 if X+Width < MaxX then begin
  RestoreScreen (1,RightDir,d2);
  Inc(Spr[1].X,d2);
  DrawSprite (1);
 end;
end;

procedure ShowLives;
begin
 str(Lives,s);
 setfillstyle (SolidFill,White);
 setcolor (Red);
 bar (80,0,110,10);
 outtextxy (82,2,s);
end;

procedure ShowScore;
begin
 str(Score,s);
 setfillstyle (SolidFill,White);
 setcolor (Blue);
 bar (150,0,250,10);
 outtextxy (152,2,s);
end;

procedure ShowShoots;
begin
 str(CurrentShoots,s);
 setfillstyle (SolidFill,White);
 setcolor (Black);
 bar (20,0,50,10);
 outtextxy (20,2,s);
end;

procedure ShowLevel;
begin
 str(Level,s);
 setfillstyle (SolidFill,White);
 setcolor (Blue);
 bar (251,0,350,10);
 outtextxy (253,2,'Level '+s);
end;

procedure Shoot;
var i:integer;
begin
 if CurrentShoots>0 then begin
  for i:=1 to MaxShoots do if (Sec<>Sec1) and (Shoots[i].State=0) then begin
   Dec(CurrentShoots);
   ShowShoots;
   Spr[1].PNum:=6;
   DrawSprite (1);
   GetTime(Hour,Min,Sec,Sec100);
   ShootX:=Spr[1].X;
   Shooter:=True;
   Shoots[i].X:=Spr[1].X+ (Width div 2);
   Shoots[i].Y:=Spr[1].Y - 5;
   Shoots[i].PNum:=UpDir;
   Shoots[i].State:=1;
   break;
  end;
 end;
end;

procedure Help(s:string);
begin
 setfillstyle (SolidFill,White);
 setcolor (Blue);
 bar (10,MaxY-10,MaxX-10,MaxY);
 outtextxy (10,MaxY-9,s);
end;

procedure Error (Code:integer; str:String);
begin
 Window (Cx-120,Cy-100,Cx+120,Cy-70,Black,Yellow);
 case Code of
  1: s:=' '+str+'  !';
 end;
 settextjustify (LeftText, TopText);
 SetTextStyle(DefaultFont, HorizDir, 1);
 outtextxy (Cx-116,Cy-92,s);
 Wait;
 CloseAll;
 Halt(Code);
end;

procedure DrawField;
var i,x,y:integer;
begin
 ClearScreen;
 with Spr[1] do begin
  State:=1;
  Pnum:=1;
  X:=MaxX div 2;
  Y:=MaxY - 10 - Height;
  DrawSprite (1);
 end;
 x:=100;
 y:=10;
 for i:=2 to CurrentSprites do begin
  Spr[i].State:=1;
  Spr[i].PNum:=7;
  Spr[i].x:=x;
  Spr[i].y:=y;
  DrawSprite (i);
  inc(x,50);
  if x>MaxX-Width then begin
   x:=100;
   if y<CurrentBottom-Height then Inc(y,Height)
   else y:=10;
  end;
 end;
 for i:=1 to MaxShoots do Shoots[i].State:=0;
 Shooter:=False;
 EnemyShooter:=-1;
 Sec:=0; SecN:=0;
 SecI1:=100; Sec1:=100; SecN1:=100;
 setfillstyle (SolidFill,Red);
 FillEllipse (10,5,5,4);
 ShowShoots;
 setfillstyle (SolidFill,Green);
 bar (60,1,72,10);
 setfillstyle (SolidFill,LightGreen);
 bar (62,3,70,8);
 ShowLives;
 setfillstyle (SolidFill,Yellow);
 setcolor (Black);
 for i:=1 to 3 do begin
  circle (126+i*2,5,4);
  FillEllipse (126+i*2,5,4,4);
 end;
 ShowScore;
 ShowLevel;
 InGame:=True;
end;

procedure LoadSprites;
var F:Text;
 n,i,j,r:integer;
 b:char;
begin
 assign (f,SprName);
 {$I-}
 reset (f);
 {$I+}
 if IoResult<>0 then Error (1,SprName);
 For n:=1 to MaxPictures do
 For j:=0 to Height-1 do
 for i:=0 to Width-1 do begin
  read (f,b);
  Pict [n,i,j]:=b;
 end;
 close (f);
end;

procedure Deltas (SNum,Dir:integer; var dx,dy:integer);
var x,y:integer;
begin
 x:=Spr[SNum].X;
 y:=Spr[SNum].Y;
 case Dir of
  LeftDir: begin
   Dec(x,Delta);
   if x<0 then x:=0;
  end;
  RightDir: begin
   Inc(x,Delta);
   if x>MaxX-Width then x:=MaxX-Width;
  end;
  UpDir: begin
   Dec (y,Delta);
   if y<10 then y:=10;
  end;
  DownDir: begin
   Inc(y,Delta);
   if y>CurrentBottom then y:=CurrentBottom;
  end;
 end;
 dx:=x;
 dy:=y;
end;

function Between (a,x,b:integer):boolean;
begin
 if (x>a) and (x<b) then Between:=true
 else Between:=false;
end;

procedure ShootMovies;
var i,d,n:integer;
 X,Y:Word;
 found:boolean;
begin
 for i:=1 to MaxShoots do if Shoots[i].State=1 then begin
  x:=Shoots[i].X;
  y:=Shoots[i].Y;
  d:=Shoots[i].PNum;
  setfillstyle (SolidFill,White);
  setcolor (White);
  fillellipse (x,y,Shootradius,Shootradius);
  if d=updir then begin
   setfillstyle (SolidFill,Red);
   if y<15 then begin
    Shoots[i].State:=0;
    continue;
   end;
   found:=false;
   for n:=2 to CurrentSprites do begin
    if Spr[n].State=1 then begin
     if (Between(Spr[n].x,x,Spr[n].x+Width)) and
        (Between(Spr[n].y,y,Spr[n].y+Height)) then begin
      Shoots[i].State:=0;
      found:=true;
      Spr[n].State:=2;
      Inc(Spr[n].PNum);
      Inc(Score,10+5*n);
      ShowScore;
      break;
     end;
    end;
   end;
   if not found then Dec(y,Delta);
  end
  else begin
   setfillstyle (SolidFill,Blue);
   if y>MaxY-10-(Height div 2) then begin
    Shoots[i].State:=0;
    continue;
   end;
   found:=false;
   if Between(Spr[1].x,x,Spr[1].x+Width) and
      Between(Spr[1].y,y,Spr[1].y+Height) then begin
    Shoots[i].State:=0;
    found:=true;
    Inc(Spr[1].Pnum);
    DieMe:=True;
    Help ('You are missed one life :-(');
    DrawSprite (1);
   end;
   if not found then Inc(y,Delta);
  end;
  if not found then begin
   fillellipse (x,y,Shootradius,Shootradius);
   Shoots[i].X:=x;
   Shoots[i].Y:=y;
  end;
 end;
end;

procedure EnemiesStep;
var i,k,Dir,dx,dy,n:integer;
begin
 Enemies:=0;
 for i:=2 to CurrentSprites do begin
  if Spr[i].State=1 then begin
   Inc(Enemies);
   for k:=1 to 3 do begin
    dir:=Random(4);
    if dir=Spr[i].predir then break;
   end;
   Spr[i].predir:=dir;
   Deltas (i, dir, dx, dy);
   RestoreScreen (i,Dir,Delta);
   Spr[i].X:=dx;
   Spr[i].Y:=dy;
   DrawSprite (i);
   InitShoot:=False;
   GetTime(Hour,Min,SecN1,Sec100);
   if (SecN1<>SecN) and (1+random(100)<ShootsProbability) then InitShoot:=True;
   if InitShoot then begin
    SecN:=SecN1;
    for n:=1 to MaxShoots do
    if (Shoots[n].State=0) and (EnemyShooter<>i) then begin
     EnemyShooter:=i;
     Shoots[n].X:=dX+ (Width div 2);
     Shoots[n].Y:=dY +Height +5;
     Shoots[n].PNum:=DownDir;
     Shoots[n].State:=1;
     break;
    end;
   end;
  end
  else if Spr[i].State=2 then begin
   GetTime (Hour,Min,SecI,Sec100);
   DrawSprite (i);
   if SecI<>SecI1 then begin
    SecI1:=SecI;
    if (Spr[i].PNum<11) then Inc(Spr[i].PNum)
    else begin
     Spr[i].State:=0;
     setfillstyle (SolidFill, White);
     bar (Spr[i].X,Spr[i].Y,Spr[i].X+Width-1,Spr[i].Y+Height-1);
    end;
   end;
  end;
 end;
end;

procedure TimeFunctions;
var i:integer;
begin
 if not InGame then Exit;
 GetTime(Hour,Min,Sec1,Sec100);
 if (Shooter) and (Sec<>Sec1) then begin
  Spr[1].PNum:=1;
  if ShootX=Spr[1].X then DrawSprite (1);
  Shooter:=False;
 end;
 if (DieMe) and (Sec<>Sec1) then begin
  if Spr[1].Pnum<5 then begin
   Sec:=Sec1;
   Inc(Spr[1].PNum);
   DrawSprite (1);
   DieMe:=True;
  end
  else begin
   DieMe:=False;
   if Lives>0 then begin
    Dec(Lives);
    ShowLives;
    Spr[1].PNum:=1;
    DrawSprite (1);
   end
   else InGame:=False;
  end;
 end;
end;

label 10,20;
begin
 Randomize;
 InitAll;
 InGame:=False;
 Start;
 settextstyle (DefaultFont,HorizDir,1);
 settextjustify (LeftText,TopText);
 LoadSprites;
 CurrentBottom:=200;
 CurrentShoots:=50;
 Lives:=3;
 Score:=0;
 Level:=1;
 ShootsProbability:=5;
 CurrentSprites:=5;
10:
 DrawField;
 if Level>1 then begin
  Str(Level-1,s);
  Help ('Cool, you''re complete level '+s);
 end
 else Help ('Let''s go! Kill them, invaders!');
 repeat
  if InGame then repeat
   EnemiesStep;
   if Enemies=0 then begin
    Inc(Score,100+Level*10);
    if ShootsProbability<100 then Inc (ShootsProbability);
    if CurrentSprites<MaxSprites then Inc(CurrentSprites);
    if CurrentBottom<MaxY-10-4*Height then Inc(CurrentBottom,10);
    CurrentShoots:=50;
    Delay (1000);
    Inc(Level);
    goto 10;
   end;
   ShootMovies;
   if not InGame then begin
    Help ('Sorry, you''re dead');
   end;
   TimeFunctions;
  until keypressed;
  Ch:=ReadKey;
  case Ch of
   SPACE: if not DieMe and InGame then Shoot;
   #0: begin
    Ch:=ReadKey;
    case Ch of
     F1: Help ('You need HELP there? You''re VERY strange man :-)');
     LEFT: if not DieMe and InGame then GoLeft;
     RIGHT: if not DieMe and InGame then GoRight;
     UP: if not DieMe and InGame then Shoot;
    end;
   end;
  end;
 until Ch=ESC;
 CloseAll;
end.
